<?php
/*------------------------------------------------------------------
* Universidad del Cauca - Departamento de Sistemas
* Edwin Caldon
* ecaldon en unicauca punto edu punto co
* Powered by The Quanta+
------------------------------------------------------------------*/

//Dependiendo del dia-mes-anio me dice a que numero de la semana
//pertenece el dia (0-> Domingo, ..., 6-> Sabado)
 function numero_dia_semana($d,$m,$a)
{ 
  $f = getdate(mktime(0,0,0,$m,$d,$a)); 
  $d = $f["wday"];
  return $d;
}

//cantidad de dias de un mes
function numero_dias_mes($m,$a)
{     
	if($m == 1 or $m==3 or $m==5 or $m==7 or $m==8 or $m==10 or $m==12){
		$valor = 31;
	}elseif ($m==2){
		if (((($a%4)==0) and (($a%100)!=0)) or (($a%400)==0))
  		{
    		$valor = 29;
  		}
  		else
  		{
    		$valor = 28; 
  		}
	}
	else $valor = 30;

	return $valor;
}

//Definimos los meses como un arreglo de cadenas(0=>Enero, ..., 11=>Diciembre)
$mes=array('Enero','Febrero','Marzo','Abril','Mayo','Junio','Julio','Agosto','Septiembre','Octubre','Noviembre','Diciembre');

//Los dias de la semana, como otro arreglo de cadenas
$semana[1]="Lunes";
$semana[2]="Martes";
$semana[3]="Miercoles"; 
$semana[4]="Jueves";
$semana[5]="Viernes";
$semana[6]="Sabado";
$semana[0]="Domingo";

//Variable para el cambio de anio
$nuevo_anio = 0;

//Me sirve como indice para el arreglo de
//los dias de la semana.
//numero entre 0-6
$dia_actual=date('w');

//Dia del mes(del sistema), numero entre 1-31
$dia_numero=date('j');

//Mes del anio(del sistema), numero entre 1-12.
//Le restamos 1 para que sirva como
//indice del arreglo de meses.
$mes_actual=date('n')-1;

//Anio del sistema, en 4 cifras
$anio_actual=date('Y');

echo "<?xml version='1.0'?>";
echo "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>";
echo "<html xmlns='http://www.w3.org/1999/xhtml' lang='es'>";
echo	"<head>";
echo		"<title>Calendario</title>";
echo	"</head>";
echo "<body>";

echo "<h2>";
echo $semana[$dia_actual]." - ";
echo $mes[$mes_actual]." ".$dia_numero." de ".$anio_actual;
echo "</h2>";

echo "<h3>";
echo "Calendario Unicauca";
echo "</h3>";

//Si el boton con nombre "calel" ha sido presionado
if (isset($_POST['calel'])) {
	$nuevo_mes = htmlentities($_POST['mes']);
	$mes_actual = array_search($nuevo_mes,$mes);
	$nuevo_anio= htmlentities($_POST['anio']);
	}

//Inicio del formulario, donde estan los selectores
//desplegables y el boton
echo "<form method='POST' action='?'>";
echo "<b>&nbsp;</b>";
echo "<select name='mes' >";
	for($i=0;$i<=11;$i++){
		if($i == $mes_actual){
			echo "<option value='".$mes[$i]."' selected='selected'>".$mes[$i]."</option>";
		}else{
			echo "<option value='".$mes[$i]."'>".$mes[$i]."</option>";
		}
	}
echo "</select>";

echo "<b>&nbsp;</b>";
echo "<select name='anio'>";
	for($anio=1990;$anio<=$anio_actual+10;$anio++){
		if($anio == $anio_actual){
			echo "<option value='".$anio."' selected='selected'>".$anio."</option>";
		} else {
			echo "<option value='".$anio."'>".$anio."</option>";
		}
	}
echo "</select>";

echo "<br/>";
echo "<input type='submit' name='calel' value='Cambiar'>";
echo "</form>";

//Una linea horizontal
echo "<hr noshade='noshade' width='50%' size='3' align='center'/>";


if ($nuevo_anio != 0)
	$anio_actual = $nuevo_anio;

$fondo_tabla = 'brown';

echo "<table border='1' bgcolor=$fondo_tabla width='30%'>";
echo 			"<tr>";
echo 				"<td align='center' bgcolor='white' colspan='4' width='1%'>";
echo 					"<font face='arial' color='black' size='2'><b>".$mes[$mes_actual]." - ".$anio_actual."</b></font>";
echo 				"</td>";
echo 		"</tr>";
echo 		"<tr>";
echo 			"<td align='center' bgcolor=$fondo_tabla width='14%'>";
echo 				"<font face='arial' color='white' size='3'><b>D</b></font>";
echo 			"</td>";
echo 			"<td align='center' bgcolor=$fondo_tabla width='15%'>";
echo 				"<font face='arial' color='white' size='3'><b>L</b></font>";
echo 			"</td>";
echo 			"<td align='center' bgcolor=$fondo_tabla width='15%'>";
echo 				"<font face='arial' color='white' size='3'><b>Ma</b></font>";
echo 			"</td>";
echo 			"<td align='center' bgcolor=$fondo_tabla width='14%'>";
echo 				"<font face='arial' color='white' size='3'><b>Mi</b></font>";
echo 			"</td>";
echo 			"<td align='center' bgcolor=$fondo_tabla width='14%'>";
echo 				"<font face='arial' color='white' size='3'><b>J</b></font>";
echo 			"</td>";
echo 			"<td align='center' bgcolor=$fondo_tabla width='14%'>";
echo 				"<font face='arial' color='white' size='3'><b>V</b></font>";
echo 			"</td>";
echo 			"<td align='center' bgcolor=$fondo_tabla width='14%'>";
echo 				"<font face='arial' color='white' size='3'><b>S</b></font>";
echo 			"</td>";
echo 		"</tr>";

$dias_mes = numero_dias_mes($mes_actual+1,$anio_actual);
$dia = 1;
$num_semanas = ceil(($dias_mes+(numero_dia_semana($dia,$mes_actual+1,$anio_actual)-1))/7);

	for ($semana=1;$semana<=$num_semanas;$semana++)
	{
  		echo 	"<tr>";
  		for ($diasem=0;$diasem<=6;$diasem++)
  		{
			$nuevo_dia = numero_dia_semana($dia,$mes_actual+1,$anio_actual);
			
			if($nuevo_dia == 0)
			{ $color='blue';}
			else
			{ $color='black';}

			if($anio_actual*10000+($mes_actual+1)*100+$dia == $anio_actual*10000+($mes_actual+1)*100+$dia_numero)
			{ $color_fondo='gray';}
			else
			{ $color_fondo='white';}

			if (($nuevo_dia==$diasem) && ($dia<=$dias_mes))
			{
				$valor = $dia;
				$dia++;
			}
			else
			{
	  			$valor = "&nbsp;";
			}

			echo "<td align='right' bgcolor=$color_fondo width='14%'>";
		    echo	"<font face='arial' color=$color size='3'>";
			echo	"<b>".$valor."</b></font>";
		    echo "</td>";
  		}
  		echo 	"</tr>";
	}

echo 		"<tr>";
echo 			"<td align='center' colspan='7'>";
echo 				"<font face='arial' size='1' color='black'>";
echo 				"<b>".$semana[$dia_actual]." ".$dia_numero." de ".$mes[$mes_actual]." de ".$anio_actual."</b>";
echo 				"</font>";
echo 			"</td>";
echo 		"</tr>";
echo "</table>";

echo "</body>";
echo "</html>";
?>